Name:           uthash
Version:        2.3.0
Release:        1
Summary:        Hash table for C structures
License:        BSD
URL:            https://github.com/troydhanson/uthash
Source0:        https://github.com/troydhanson/uthash/archive/v%{version}.tar.gz

BuildRequires:  asciidoc gcc make perl-interpreter perl(strict) perl(warnings)
%description
This package provides hash table for C structures. It isn't a library but a single
header file, so there is no library code to link against. It has been tested on
various platforms including Linux, Windows, Solaris, OpenBSD, FreeBSD and Android.
Most of operations on hash table are supported, such as add/replace, find, delete,
count, iterate and sort.

%package        devel
Summary:        Header and library files for uthash
Provides:       %{name} = %{version}-%{release}
Obsoletes:      %{name} < %{version}-%{release}
%description    devel
Header and library files for uthash

%package tools
Summary:        Command-line utilities for %{name}
Requires:       %{name}-devel = %{version}-%{release}
 
%description tools
This package provides the hashscan and keystats utility programs
for %{name}.
 
The hashscan program examines a running process and reports on the
uthash tables that it finds in that program’s memory.  It can also
save the keys from each table in a format that can be fed into keystats.
 
The keystats program is able to analyze which hash function has the best
characteristics on the set of keys reported by the hashscan program.

%package        help
Summary:        Documentation for uthash
BuildArch:	noarch

%description    help
Documentation for uthash

%prep
%autosetup -p1

%build
%set_build_flags
%make_build -C doc
%make_build -C tests
%make_build -C tests/threads

%install
mkdir -p %{buildroot}{%{_bindir},%{_includedir},%{_pkgdocdir}/html}
install -pm 0755 tests/{hashscan,keystats} %{buildroot}%{_bindir}
install -pm 0644 src/*.h %{buildroot}%{_includedir}
install -pm 0644 doc/*.txt tests/example.c %{buildroot}%{_pkgdocdir}
install -pm 0644 doc/*.html doc/*.css doc/*.png %{buildroot}%{_pkgdocdir}/html
rm -f %{buildroot}%{_pkgdocdir}/html/google*.html

%files          devel
%license LICENSE
%doc %dir %{_pkgdocdir}
%doc %{_pkgdocdir}/ChangeLog.txt
%{_includedir}/*.h

%files          tools
%{_bindir}/*

%files          help
%doc %{_pkgdocdir}

%changelog
* Wed Aug 23 2023 liyanan <thistleslyn@163.com> - 2.3.0-1
- Update to 2.3.0

* Tue Jun 02 2020 huanghaitao <huanghaitao8@huawei.com> - 2.1.0-1
- Change source to latest update

* Thu Mar 18 2020 zhangtao <zhangtao221@huawei.com> - 2.0.2-7
- Add stack-protector-strong flag

* Sat Dec 07 2019 lihao <lihao129@huawei.com> - 2.0.2-6
- Package Init

